
#ifndef TEST_IMPL_H
#define TEST_IMPL_H

#include "test.h"

class Employee::Impl
{
public:
    Impl();
    Impl(const Impl &);
#ifdef NO_CONST
    Impl(EmployerPtr const&, std::string const&);
#else
    Impl(ConstEmployerPtr const&, std::string const&);
#endif

public:
    unsigned int const m_id;
#ifdef LAZY_PTR
#ifdef NO_CONST
    odb::lazy_weak_ptr< Employer > m_employer;
#else
    odb::lazy_weak_ptr< const Employer > m_employer;
#endif
#else
    std::weak_ptr< const Employer > m_employer;
#endif
    std::string m_name;
};

inline Employee::Impl::Impl()
    : m_id(0)
{}

inline Employee::Impl::Impl(const Impl & other)
    : m_id(0)
    , m_employer(other.m_employer)
    , m_name(other.m_name)
{}

#ifdef NO_CONST
inline Employee::Impl::Impl(EmployerPtr const& employer, std::string const& name)
#else
inline Employee::Impl::Impl(ConstEmployerPtr const& employer, std::string const& name)
#endif
    : m_id(0)
    , m_employer(employer)
    , m_name(name)
{}

class Employer::Impl
{
public:
    Impl();
    Impl(const Impl &);
    Impl(std::string const&);

public:
    unsigned int const m_id;
    std::string m_name;
    Employees m_employees;
};

inline Employer::Impl::Impl()
    : m_id(0)
{}

inline Employer::Impl::Impl(const Impl & other)
    : m_id(0)
    , m_name(other.m_name)
    , m_employees(other.m_employees)
{}

inline Employer::Impl::Impl(std::string const& name)
    : m_id(0)
    , m_name(name)
{}

#endif //TEST_IMPL_H
